cookutils view cook @ rev 211

cook: tiny edits
author Paul Issott <paul@slitaz.org>
date Sun May 22 16:39:19 2011 +0100 (2011-05-22)
parents 57cda25558f7
children 57553966e2fb
line source
1 #!/bin/sh
2 #
3 # Cook - A tool to cook and generate SliTaz packages. Read the README
4 # before adding or modifing any code in cook!
5 #
6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
7 # Author: Christophe Lincoln <pankso@slitaz.org>
8 #
10 [ -f "/etc/slitaz/cook.conf" ] && . /etc/slitaz/cook.conf
11 [ -f "cook.conf" ] && . ./cook.conf
13 # Share DB and status with the Cooker.
14 activity="$CACHE/activity"
15 command="$CACHE/command"
16 broken="$CACHE/broken"
17 blocked="$CACHE/blocked"
19 # Old style compatibility
20 SOURCES_REPOSITORY=$SRC
22 #
23 # Functions
24 #
26 usage() {
27 cat << EOT
29 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command] [list|--option]
31 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
32 usage|help $(gettext "Display this short usage.")
33 setup $(gettext "Setup your build environment.")
34 test $(gettext "Test environment and cook a package.")
35 list-wok $(gettext "List packages in the wok.")
36 search $(gettext "Simple packages search function.")
37 new $(gettext "Create a new package with a receipt".)
38 list $(gettext "Cook a list of packages.")
39 clean-wok $(gettext "Clean-up all packages files.")
40 clean-src $(gettext "Clean-up all packages sources.")
41 pkglist $(gettext "Create all packages.* lists.")
43 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
44 --clean|-c Cook : $(gettext "clean the package in the wok.")
45 --install|-i Cook : $(gettext "cook and install the package.")
46 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
47 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
48 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
49 --interactive Cook : $(gettext "create a receipt interactively.")
50 --wok|-w Setup: $(gettext "create also a wok from Hg repo.")
52 EOT
53 exit 0
54 }
56 # Be sure we're root.
57 check_root() {
58 [ $(id -u) != 0 ] && gettext -e "\nYou must be root to cook.\n\n" && exit 0
59 }
61 separator() {
62 echo "================================================================================"
63 }
65 status() {
66 echo -en "\\033[70G[ "
67 if [ $? = 0 ]; then
68 echo -en "\\033[1;32mOK"
69 else
70 echo -en "\\033[1;31mFailed"
71 fi
72 echo -e "\\033[0;39m ]"
73 }
75 # Log activities, we want first letter capitalized.
76 log() {
77 grep ^[A-Z] | \
78 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
79 }
81 # We don't want these escapes in web interface.
82 clean_log() {
83 sed -i -e s'|\[70G\[ \[1;32m| |' \
84 -e s'|\[0;39m \]||' $LOGS/$pkg.log
85 }
87 # Log broken packages.
88 broken() {
89 if ! grep -q "^$pkg$" $broken; then
90 echo "$pkg" >> $broken
91 fi
92 }
94 # Be sure package exists in wok.
95 check_pkg_in_wok() {
96 if [ ! -d "$WOK/$pkg" ]; then
97 gettext -e "\nUnable to find package in the wok:"
98 echo -e " $pkg\n" && exit 1
99 fi
100 }
102 if_empty_value() {
103 if [ -z "$value" ]; then
104 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
105 exit 1
106 fi
107 }
109 # Initialize files used in $CACHE
110 init_db_files() {
111 gettext "Creating directories structure in:"; echo " $SLITAZ"
112 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
113 gettext "Creating DB files in:"; echo " $CACHE"
114 for f in $activity $command $broken $blocked
115 do
116 touch $f
117 done
118 }
120 # QA: check a receipt consistency before building.
121 receipt_quality() {
122 gettext -e "QA: checking package receipt...\n"
123 unset online
124 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
125 online="online"
126 fi
127 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
128 do
129 unset value
130 value=$(grep ^$var= $receipt | cut -d \" -f 2)
131 case "$var" in
132 PACKAGE|VERSION|SHORT_DESC)
133 if_empty_value ;;
134 CATEGORY)
135 [ -z "$value" ] && value="empty"
136 valid="base-system x-window utilities network graphics \
137 multimedia office development system-tools security games \
138 misc meta non-free"
139 if ! echo "$valid" | grep -q -w "$value"; then
140 gettext "QA: unknown category:"; echo -e " $value\n"
141 exit 1
142 fi ;;
143 WEB_SITE)
144 # We don't check WGET_URL since if dl is needed it will fail.
145 # Break also if we're not online. Here error is not fatal.
146 if_empty_value
147 [ -z "$online" ] || break
148 if ! busybox wget -T 12 -s $value 2>/dev/null; then
149 gettext "QA: Unable to reach:"; echo -e " $value"
150 fi ;;
151 esac
152 done
153 }
155 # Executed before sourcing a receipt.
156 unset_receipt() {
157 unset DEPENDS BUILD_DEPENDS WANTED EXTRAVERSION WGET_URL PROVIDE TARBALL
158 }
160 # Paths used in receipt and by cook itself.
161 set_paths() {
162 pkgdir=$WOK/$PACKAGE
163 src=$pkgdir/source/$PACKAGE-$VERSION
164 taz=$pkgdir/taz
165 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
166 fs=$pack/fs
167 stuff=$pkgdir/stuff
168 install=$pkgdir/install
169 if [ "$WANTED" ]; then
170 src=$WOK/$WANTED/source/$WANTED-$VERSION
171 install=$WOK/$WANTED/install
172 wanted_stuff=$WOK/$WANTED/stuff
173 fi
174 # Old way compatibility.
175 _pkg=$install
176 }
178 # Create source tarball when URL is a SCM.
179 create_tarball() {
180 gettext "Creating tarball: "; echo "$tarball"
181 if [ "$LZMA_SRC" ]; then
182 tar -c $pkgsrc | lzma e $SRC/$tarball -si || exit 1
183 else
184 tar cjf $tarball $pkgsrc || exit 1
185 mv $tarball $SRC && rm -rf $pkgsrc
186 fi
187 }
189 # Get package source. For SCM we are in cache so clone here and create a
190 # tarball here.
191 get_source() {
192 pwd=$(pwd)
193 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
194 tarball=$pkgsrc.tar.bz2
195 [ "$LZMA_SRC" ] && tarball=$pkgsrc.tar.lzma
196 case "$WGET_URL" in
197 http://*|ftp://*)
198 # Busybox Wget is better!
199 busybox wget -T 12 -c -P $SRC $WGET_URL || \
200 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
201 https://*)
202 wget -c --no-check-certificate -P $SRC $WGET_URL || \
203 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
204 hg*|mercurial*)
205 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
206 url=${WGET_URL#hg|}
207 else
208 url=${WGET_URL#mercurial|}
209 fi
210 gettext -e "Getting source from Hg...\n"
211 echo "URL: $url"
212 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
213 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
214 create_tarball ;;
215 git*)
216 url=${WGET_URL#git|}
217 gettext -e "Getting source from Git...\n"
218 echo "URL: $url"
219 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
220 if [ "$BRANCH" ]; then
221 echo "Git branch: $BRANCH"
222 cd $pkgsrc && git checkout $BRANCH && cd ..
223 fi
224 create_tarball ;;
225 cvs*)
226 url=${WGET_URL#cvs|}
227 mod=$PACKAGE
228 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
229 gettext -e "Getting source from CVS...\n"
230 echo "URL: $url"
231 [ "$CVS_MODULE" ] && echo "CVS module: $mod"
232 gettext "Cloning to: "; echo "$pwd/$mod"
233 cvs -d:$url co $mod && mv $mod $pkgsrc
234 create_tarball ;;
235 svn*|subversion*)
236 if $(echo "$WGET_URL" | fgrep -q "svn|"); then
237 url=${WGET_URL#svn|}
238 else
239 url=${WGET_URL#subversion|}
240 fi
241 gettext -e "Getting source from SVN...\n"
242 echo "URL: $url"
243 if [ "$BRANCH" ]; then
244 echo t | svn co $url -r $BRANCH $pkgsrc
245 else
246 echo t | svn co $url $pkgsrc
247 fi
248 create_tarball ;;
249 *)
250 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
251 tee -a $LOGS/$PACKAGE.log
252 exit 1 ;;
253 esac
254 }
256 # Extract source package.
257 extract_source() {
258 if [ ! -s "$SRC/$TARBALL" ]; then
259 local url
260 url="http://mirror.slitaz.org/sources/packages"
261 url=$url/${TARBALL:0:1}/$TARBALL
262 gettext "Getting source from mirror:"; echo " $url"
263 busybox wget -c -P $SRC $url || echo -e "ERROR: wget $url"
264 fi
265 gettext "Extracting:"; echo " $TARBALL"
266 case "$TARBALL" in
267 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
268 *.tar.bz2|*.tbz|*.tbz2) tar xjf $SRC/$TARBALL 2>/dev/null ;;
269 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
270 *.tar) tar xf $SRC/$TARBALL ;;
271 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
272 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
273 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
274 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
275 *) cp $SRC/$TARBALL $(pwd) ;;
276 esac
277 }
279 # Display cooked package summary.
280 summary() {
281 cd $WOK/$pkg
282 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
283 fs=$(du -sh taz/* | awk '{print $1}')
284 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
285 files=$(cat taz/$pkg-*/files.list | wc -l)
286 cookdate=$(date "+%Y-%m-%d %H:%M")
287 sec=$time
288 div=$(($time / 60))
289 [ "$div" != 0 ] && min="~ ${div}m"
290 gettext "Summary for:"; echo " $PACKAGE $VERSION"
291 separator
292 [ "$prod" ] && echo "Produced : $prod"
293 cat << EOT
294 Packed : $fs
295 Compressed : $size
296 Files : $files
297 Cook time : ${sec}s $min
298 Cook date : $cookdate
299 $(separator)
300 EOT
301 }
303 # Display debugging error info.
304 debug_info() {
305 echo -e "\nDebug information"
306 separator
307 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
308 for error in \
309 ERROR "No package" "cp: can't" "can't open" "can't cd" \
310 "error:" "fatal error:"
311 do
312 fgrep "$error" $LOGS/$pkg.log
313 done
314 separator && echo ""
315 }
317 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
318 # so some packages need to copy these files with the receipt and genpkg_rules.
319 copy_generic_files()
320 {
321 # $LOCALE is set in cook.conf
322 if [ "$LOCALE" ]; then
323 if [ -d "$_pkg/usr/share/locale" ]; then
324 mkdir -p $fs/usr/share/locale
325 for i in $LOCALE
326 do
327 if [ -d "$_pkg/usr/share/locale/$i" ]; then
328 cp -a $_pkg/usr/share/locale/$i $fs/usr/share/locale
329 fi
330 done
331 fi
332 fi
334 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
335 if [ "$GENERIC_PIXMAPS" != "no" ]; then
336 if [ -d "$_pkg/usr/share/pixmaps" ]; then
337 mkdir -p $fs/usr/share/pixmaps
338 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.png \
339 $fs/usr/share/pixmaps 2>/dev/null
340 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.xpm \
341 $fs/usr/share/pixmaps 2>/dev/null
342 fi
344 # Custom or homemade PNG pixmap can be in stuff.
345 if [ -f "$stuff/$PACKAGE.png" ]; then
346 mkdir -p $fs/usr/share/pixmaps
347 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
348 fi
349 fi
351 # Desktop entry (.desktop).
352 if [ -d "$_pkg/usr/share/applications" ]; then
353 cp -a $_pkg/usr/share/applications $fs/usr/share
354 fi
356 # Homemade desktop file(s) can be in stuff.
357 if [ -d "$stuff/applications" ]; then
358 mkdir -p $fs/usr/share
359 cp -a $stuff/applications $fs/usr/share
360 fi
361 if [ -f "$stuff/$PACKAGE.desktop" ]; then
362 mkdir -p $fs/usr/share/applications
363 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
364 fi
365 }
367 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
368 # as removing uneeded files like in Python packages.
369 strip_package()
370 {
371 gettext "Executing strip on all files..."
372 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
373 do
374 if [ -d "$dir" ]; then
375 find $dir -type f -exec strip -s '{}' 2>/dev/null \;
376 fi
377 done
378 find $fs -name "*.so*" -exec strip -s '{}' 2>/dev/null \;
379 find $fs -name "*.a" -exec strip --strip-debug '{}' 2>/dev/null \;
380 status
382 # Remove Python .pyc and .pyo from packages.
383 if echo "$PACKAGE $DEPENDS" | fgrep -q "python"; then
384 gettext "Removing Python compiled files..."
385 find $fs -type f -name "*.pyc" -delete 2>/dev/null
386 find $fs -type f -name "*.pyo" -delete 2>/dev/null
387 status
388 fi
390 # Remove Perl perllocal.pod and .packlist from packages.
391 if echo "$DEPENDS" | fgrep -q "perl"; then
392 gettext "Removing Perl compiled files..."
393 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
394 find $fs -type f -name ".packlist" -delete 2>/dev/null
395 status
396 fi
397 }
399 # Remove installed deps.
400 remove_deps() {
401 # Now remove installed build deps.
402 diff="$CACHE/installed.cook.diff"
403 if [ -s "$CACHE/installed.cook.diff" ]; then
404 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
405 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
406 gettext "Build dependencies to remove:"; echo " $nb"
407 gettext "Removing:"
408 for dep in $deps
409 do
410 echo -n " $dep"
411 echo 'y' | tazpkg remove $dep >/dev/null
412 done
413 echo -e "\n"
414 # Keep the last diff for debug and info.
415 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
416 fi
417 }
419 # The main cook function.
420 cookit() {
421 echo "Cook: $PACKAGE $VERSION"
422 separator
423 set_paths
424 [ "$QA" ] && receipt_quality
425 cd $pkgdir
426 rm -rf install taz source
428 # Disable -pipe if less than 512Mb free RAM.
429 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
430 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
431 gettext -e "Disabling -pipe compile flag: $free RAM\n"
432 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
433 CXXFLAGS="${CXXFLAGS/-pipe}" && \
434 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
435 fi
436 unset free
438 # Export flags and path to be used by make
439 DESTDIR=$pkgdir/install
440 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS BUILD_HOST CONFIG_SITE
441 local LC_ALL=POSIX LANG=POSIX
443 # Check for build deps and handle implicit depends of *-dev packages
444 # (ex: libusb-dev :: libusb).
445 cd $INSTALLED && ls -1 > $CACHE/installed.list
446 rm -f $CACHE/missing
447 [ "$DEPENDS" ] && gettext -e "Checking build dependencies...\n"
448 for dep in $BUILD_DEPENDS
449 do
450 implicit=${dep%-dev}
451 for i in $dep $implicit
452 do
453 if [ ! -f "$INSTALLED/$i/receipt" ]; then
454 # Try local package first. In some cases implicit doesn't exist, ex:
455 # libboost-dev exists but not libboost, so check if we got vers.
456 unset vers
457 vers=$(grep ^VERSION= $WOK/$i/receipt 2>/dev/null | cut -d '"' -f 2)
458 if [ -f "$PKGS/$i-$vers.tazpkg" ]; then
459 gettext "Installing dep (pkg/local):"; echo " $i $vers"
460 cd $PKGS && tazpkg install $i-$vers.tazpkg >/dev/null
461 else
462 if [ "$vers" ]; then
463 if fgrep -q $i-$vers $DB/packages.list; then
464 gettext "Installing dep (web/cache):"; echo " $i $vers"
465 tazpkg get-install $i >/dev/null
466 else
467 # So package exists in wok but not available.
468 gettext "Missing dep (wok/pkg) :"; echo " $i $vers"
469 echo $i >> $CACHE/missing
470 fi
471 fi
472 fi
473 fi
474 done
475 done
476 cd $INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
478 # If a cook failed deps are removed.
479 [ ! -s "installed.cook.diff" ] && \
480 busybox diff installed.list installed.cook > installed.cook.diff
481 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
483 # Have we a missing build dep to cook ?
484 if [ -s "$CACHE/missing" ] && [ "$AUTO_COOK" ]; then
485 gettext -e "Auto cook config is set : AUTO_COOK\n"
486 cp -f $LOGS/$PACKAGE.log $LOGS/$PACKAGE.log.$$
487 for i in $(cat $CACHE/missing)
488 do
489 (gettext "Building dep (wok/pkg) :"; echo " $i $vers") | \
490 tee -a $LOGS/$PACKAGE.log.$$
491 cook $i || (echo -e "ERROR: can't cook dep '$i'\n" && \
492 fgrep "remove: " $LOGS/$i.log && \
493 fgrep "Removing: " $LOGS/$i.log && echo "") | \
494 tee -a $LOGS/$PACKAGE.log.$$ && break
495 done
496 rm -f $CACHE/missing
497 mv $LOGS/$PACKAGE.log.$$ $LOGS/$PACKAGE.log
498 fi
500 # QA: Exit on missing dep errors. We exit in both cases, if AUTO_COOK
501 # is enabled and cook fails we have ERROR in log, if no auto cook we have
502 # missing dep in cached file.
503 if fgrep -q "ERROR:" $LOGS/$pkg.log || [ -s "$CACHE/missing" ]; then
504 [ -s "$CACHE/missing" ] && nb=$(cat $CACHE/missing | wc -l)
505 echo -e "ERROR: missing dep $nb\n"
506 exit 1
507 fi
509 # Get source tarball and make sure we have source dir named:
510 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
511 # tarball if it exists.
512 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
513 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
514 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
515 LZMA_SRC=""
516 else
517 get_source || exit 1
518 fi
519 fi
520 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
521 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
522 extract_source || exit 1
523 if [ "$LZMA_SRC" ]; then
524 cd $pkgdir/source
525 if [ "$(ls -A tmp | wc -l)" -gl 1 ] || [ -f "$(echo tmp/*)" ]; then
526 mv tmp tmp-1 && mkdir tmp
527 mv tmp-1 tmp/${SOURCE:-$PACKAGE}-$VERSION
528 fi
529 if [ -d "tmp/${SOURCE:-$PACKAGE}-$VERSION" ]; then
530 cd tmp && tar -c * | lzma e $SRC/$TARBALL -si
531 fi
532 fi
533 cd $pkgdir/source/tmp
534 # Some archives are not well done and don't extract to one dir (ex lzma).
535 files=$(ls | wc -l)
536 [ "$files" == 1 ] && mv * ../$PACKAGE-$VERSION
537 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
538 mv * ../$PACKAGE-$VERSION
539 cd .. && rm -rf tmp
540 fi
542 # Execute receipt rules.
543 if grep -q ^compile_rules $receipt; then
544 gettext -e "Executing: compile_rules\n"
545 [ -d "$src" ] && cd $src
546 compile_rules $@ || exit 1
547 # Stay compatible with _pkg
548 [ -d "$src/_pkg" ] && mv $src/_pkg $install
549 # QA: compile_rules success so valid.
550 mkdir -p $install
551 else
552 # QA: No compile_rules so no error, valid.
553 mkdir -p $install
554 fi
555 separator && echo ""
556 }
558 # Cook quality assurance.
559 cookit_quality() {
560 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
561 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
562 fi
563 # ERROR can be echoed any time in cookit()
564 if fgrep -q ERROR: $LOGS/$pkg.log; then
565 debug_info | tee -a $LOGS/$pkg.log
566 rm -f $command && exit 1
567 fi
568 }
570 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
571 # but it doesn't handle EXTRAVERSION.
572 packit() {
573 set_paths
574 echo "Pack: $PACKAGE $VERSION"
575 separator
576 if grep -q ^genpkg_rules $receipt; then
577 gettext -e "Executing: genpkg_rules\n"
578 cd $pkgdir
579 mkdir -p $fs && ( set -e; genpkg_rules ) || echo -e \
580 "\nERROR: genpkg_rules failed\n" >> $LOGS/$pkg.log
581 fi
583 # First QA check to stop now if genpkg_rules failed.
584 if fgrep -q ERROR: $LOGS/$pkg.log; then
585 exit 1
586 fi
588 cd $taz
589 for file in receipt description.txt
590 do
591 [ ! -f "../$file" ] && continue
592 gettext "Copying"; echo -n " $file..."
593 cp -f ../$file $pack && chown 0.0 $pack/$file && status
594 done
595 copy_generic_files
597 # Create files.list with redirecting find output.
598 gettext "Creating the list of files..." && cd $fs
599 find . -type f -print > ../files.list
600 find . -type l -print >> ../files.list
601 cd .. && sed -i s/'^.'/''/ files.list
602 status
604 # Strip and stuff files.
605 strip_package
607 # Md5sum of files.
608 gettext "Creating md5sum of files..."
609 while read file; do
610 [ -L "fs$file" ] && continue
611 [ -f "fs$file" ] || continue
612 case "$file" in
613 /lib/modules/*/modules.*|*.pyc) continue;;
614 esac
615 md5sum "fs$file" | sed 's/ fs/ /'
616 done < files.list > md5sum
617 status
618 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
619 description.txt 2> /dev/null | awk \
620 '{ sz=$1 } END { print sz }')
622 # Build cpio archives.
623 gettext "Compressing the fs... "
624 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
625 rm -rf fs
626 status
627 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
628 md5sum description.txt 2> /dev/null | awk \
629 '{ sz=$1 } END { print sz }')
630 gettext "Updating receipt sizes..."
631 sed -i s/^PACKED_SIZE.*$// receipt
632 sed -i s/^UNPACKED_SIZE.*$// receipt
633 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
634 status
636 # Set extra version.
637 if [ "$EXTRAVERSION" ]; then
638 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
639 sed -i s/^EXTRAVERSION.*$// receipt
640 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
641 status
642 fi
644 # Compress.
645 gettext "Creating full cpio archive... "
646 find . -print | cpio -o -H newc --quiet > \
647 ../$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg
648 status
649 gettext "Restoring original package tree... "
650 unlzma -c fs.cpio.lzma | cpio -idm --quiet
651 status
652 rm fs.cpio.lzma && cd ..
654 # QA and give info.
655 tazpkg=$(ls *.tazpkg)
656 packit_quality
657 separator && gettext "Package:"; echo -e " $tazpkg\n"
658 }
660 # Verify package quality and consistency.
661 packit_quality() {
662 #gettext "QA: Checking for broken link..."
663 #link=$(find $fs/usr -type l -follow)
664 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
665 #status
667 # Exit if any error found in log file.
668 if fgrep -q ERROR: $LOGS/$pkg.log; then
669 rm -f $command && exit 1
670 fi
672 gettext "QA: Checking for empty package..."
673 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
674 if [ "$files" -lt 0 ] && [ "$CATEGORY" != "meta" ]; then
675 echo -e "\nERROR: empty package"
676 rm -f $command && exit 1
677 else
678 # Ls sort by name so the first file is the one we want.
679 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
680 status
681 if [ -f "$old" ]; then
682 echo -n "Removing old: $(basename $old)"
683 rm -f $old && status
684 fi
685 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
686 sed -i /^${pkg}$/d $broken
687 fi
688 }
690 #
691 # Commands
692 #
694 case "$1" in
695 usage|help|-u|-h)
696 usage ;;
697 list-wok)
698 gettext -e "\nList of packages in:"; echo " $WOK"
699 separator
700 cd $WOK && ls -1
701 separator
702 echo -n "Packages: " && ls | wc -l
703 echo "" ;;
704 search)
705 # Just a simple search function, we dont need more actually.
706 query="$2"
707 gettext -e "\nSearch results for:"; echo " $query"
708 separator
709 cd $WOK && ls -1 | grep "$query"
710 separator && echo "" ;;
711 setup)
712 # Setup a build environment
713 check_root
714 echo "Cook: setting up the environment" | log
715 gettext -e "\nSetting up your environment\n"
716 separator && cd $SLITAZ
717 init_db_files
718 gettext -e "Checking for packages to install...\n"
719 for pkg in $SETUP_PKGS
720 do
721 [ ! -f "$INSTALLED/$pkg/receipt" ] && tazpkg get-install $pkg
722 done
724 # Handle --options
725 case "$2" in
726 --wok|-w)
727 [ ! -f "$INSTALLED/mercurial/receipt" ] && \
728 tazpkg get-install mercurial
729 [ -d "$WOK" ] && echo -e "A wok already exists.\n" && exit 1
730 hg clone $WOK_URL ;;
731 esac
733 # SliTaz group and permissions
734 if ! grep -q ^slitaz /etc/group; then
735 gettext -e "Adding group: slitaz\n"
736 addgroup slitaz
737 fi
738 gettext -e "Setting permissions for slitaz group...\n"
739 chown -R root.slitaz $SLITAZ
740 chmod -R g+w $SLITAZ
741 separator
742 gettext -e "All done, ready to cook packages :-)\n\n" ;;
743 test)
744 # Test a cook environment.
745 echo "Cook test: testing the cook environment" | log
746 [ ! -d "$WOK" ] && exit 1
747 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
748 cook cooktest ;;
749 new)
750 # Create the package folder and an empty receipt.
751 pkg="$2"
752 [ "$pkg" ] || usage
753 echo ""
754 if [ -d "$WOK/$pkg" ]; then
755 echo -n "$pkg " && gettext "package already exists."
756 echo -e "\n" && exit 1
757 fi
758 gettext "Creating"; echo -n " $WOK/$pkg"
759 mkdir $WOK/$pkg && cd $WOK/$pkg && status
760 gettext "Preparing the package receipt..."
761 cp $DATA/receipt .
762 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
763 status && echo ""
765 # Interactive mode, asking and seding.
766 case "$3" in
767 --interactive|-i)
768 gettext -e "Entering interactive mode...\n"
769 separator
770 echo "Package : $pkg"
771 # Version.
772 echo -n "Version : " ; read anser
773 sed -i s/'VERSION=\"\"'/"VERSION=\"$anser\""/ receipt
774 # Category.
775 echo -n "Category : " ; read anser
776 sed -i s/'CATEGORY=\"\"'/"CATEGORY=\"$anser\""/ receipt
777 # Short description.
778 echo -n "Short desc : " ; read anser
779 sed -i s/'SHORT_DESC=\"\"'/"SHORT_DESC=\"$anser\""/ receipt
780 # Maintainer.
781 echo -n "Maintainer : " ; read anser
782 sed -i s/'MAINTAINER=\"\"'/"MAINTAINER=\"$anser\""/ receipt
783 # Web site.
784 echo -n "Web site : " ; read anser
785 sed -i s#'WEB_SITE=\"\"'#"WEB_SITE=\"$anser\""# receipt
786 echo ""
787 # Wget URL.
788 echo "Wget URL to download source tarball."
789 echo "Example : \$GNU_MIRROR/\$PACKAGE/\$TARBALL"
790 echo -n "Wget url : " ; read anser
791 sed -i s#'WGET_URL=\"$TARBALL\"'#"WGET_URL=\"$anser\""# receipt
792 # Ask for a stuff dir.
793 echo -n "Do you need a stuff directory ? (y/N) : " ; read anser
794 if [ "$anser" = "y" ]; then
795 echo -n "Creating the stuff directory..."
796 mkdir $WOK/$pkg/stuff && status
797 fi
798 # Ask for a description file.
799 echo -n "Are you going to write a description ? (y/N) : " ; read anser
800 if [ "$anser" = "y" ]; then
801 echo -n "Creating the description.txt file..."
802 echo "" > $WOK/$pkg/description.txt && status
803 fi
804 separator
805 gettext -e "Receipt is ready to use.\n"
806 echo "" ;;
807 esac ;;
808 list)
809 # Cook a list of packages (better use the Cooker since it will order
810 # packages before executing cook).
811 check_root
812 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
813 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
814 echo -e " $2\n" && exit 1
815 echo "Cook list starting: $2" | log
816 for pkg in $(cat $2)
817 do
818 cook $pkg || broken
819 done ;;
820 clean-wok)
821 check_root
822 gettext -e "\nCleaning all packages files..."
823 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
824 status && echo "" ;;
825 clean-src)
826 check_root
827 gettext -e "\nCleaning all packages sources..."
828 rm -rf $WOK/*/source
829 status && echo "" ;;
830 pkglist)
831 # Create suitable packages list for TazPKG and only for built packages.
832 [ "$2" ] && PKGS="$2"
833 [ ! -d "$PKGS" ] && \
834 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1
835 echo "cook:pkglist" > $command
836 echo "Cook pkglist: Creating all packages lists" | log
837 gettext -e "\nCreating lists for:"; echo " $PKGS"
838 separator
839 cd $PKGS
840 rm -f packages.*
841 gettext -e "Creating: packages.list\n"
842 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
843 gettext -e "Creating: packages.md5\n"
844 md5sum *.tazpkg > $PKGS/packages.md5
845 gettext -e "Creating: packages.desc\n"
846 gettext -e "Creating: packages.txt\n"
847 gettext -e "Creating: packages.equiv\n"
848 cd $WOK
849 for pkg in *
850 do
851 unset_receipt
852 . $pkg/receipt
853 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
854 # packages.desc lets us search easily in DB
855 cat >> $PKGS/packages.desc << EOT
856 $PACKAGE | $VERSION$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
857 EOT
858 # packages.txt used by tazpkg and tazpkg-web also to provide
859 # a human readable package list with version and description.
860 cat >> $PKGS/packages.txt << EOT
861 $PACKAGE
862 ${VERSION}$EXTRAVERSION
863 $SHORT_DESC
864 $PACKED_SIZE ($UNPACKED_SIZE installed)
866 EOT
867 # packages.equiv is used by tazpkg install to check depends.
868 for i in $PROVIDE; do
869 DEST=""
870 echo $i | fgrep -q : && DEST="${i#*:}:"
871 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
872 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
873 $PKGS/packages.equiv
874 else
875 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
876 fi
877 done
878 # files.list provides a list of all packages files.
879 cat $pkg/taz/*/files.list | sed s/^/"$pkg: \0"/ >> \
880 $PKGS/files.list
881 fi
882 done
883 cd $PKGS
885 # files.list.lzma
886 gettext -e "Creating: files.list.lzma\n"
887 lzma e files.list files.list.lzma
888 rm -f files.list
890 separator
891 nb=$(ls $PKGS/*.tazpkg | wc -l)
892 echo -e "Packages: $nb\n"
893 rm -f $command ;;
894 *)
895 # Just cook and generate a package.
896 check_root
897 time=$(date +%s)
898 pkg="$1"
899 [ -z "$pkg" ] && usage
900 receipt="$WOK/$pkg/receipt"
901 check_pkg_in_wok && echo ""
903 # Display and log info if cook process stopped.
904 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
905 tee -a $LOGS/$pkg.log' INT
907 # Skip blocked, 3 lines also for the Cooker.
908 if grep -q "^$pkg$" $blocked && [ "$2" != "--unblock" ]; then
909 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
910 fi
912 # Log and source receipt.
913 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
914 echo "cook:$pkg" > $command
915 unset inst
916 unset_receipt
917 . $receipt
919 # Handle --options
920 case "$2" in
921 --clean|-c)
922 gettext -e "Cleaning:"; echo -n " $pkg"
923 cd $WOK/$pkg && rm -rf install taz source
924 status && echo "" && exit 0 ;;
925 --install|-i)
926 inst='yes' ;;
927 --getsrc|-gs)
928 gettext "Getting source for:"; echo " $pkg"
929 separator && get_source
930 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
931 --block|-b)
932 gettext "Blocking:"; echo -n " $pkg"
933 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
934 status && echo "" && exit 0 ;;
935 --unblock|-ub)
936 gettext "Unblocking:"; echo -n " $pkg"
937 sed -i "/^${pkg}$/"d $blocked
938 status && echo "" && exit 0 ;;
940 esac
942 # Check if wanted is built now so we have separate log files.
943 if [ "$WANTED" ] && [ ! -d "$WOK/$WANTED/install" ]; then
944 if ! grep -q "^$WANTED$" $broken; then
945 cook "$WANTED"
946 fi
947 fi
949 # Cook and pack or exit on error and log everything.
950 cookit $@ 2>&1 | tee $LOGS/$pkg.log
951 remove_deps | tee -a $LOGS/$pkg.log
952 cookit_quality
953 packit 2>&1 | tee -a $LOGS/$pkg.log
954 clean_log
956 # Exit if any error in packing.
957 if grep -q ^ERROR $LOGS/$pkg.log; then
958 debug_info | tee -a $LOGS/$pkg.log
959 rm -f $command && exit 1
960 fi
962 # Time and summary
963 time=$(($(date +%s) - $time))
964 summary | tee -a $LOGS/$pkg.log
965 echo ""
967 # Install package if requested
968 if [ "$inst" ]; then
969 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
970 cd $PKGS && tazpkg install \
971 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
972 else
973 gettext -e "Unable to install package, build has failed.\n\n"
974 exit 1
975 fi
976 fi
977 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
978 # You want automation: use the Cooker Build Bot.
979 #[ -d "$WOK/$pkg-dev" ] && cook $pkg-dev
980 rm -f $command ;;
981 esac
983 exit 0